package com.tzld.piaoquan.longarticle.service.local.impl;

import com.tzld.piaoquan.longarticle.dao.mapper.AccountSpecialSettingsMapper;
import com.tzld.piaoquan.longarticle.model.po.AccountSpecialSettings;
import com.tzld.piaoquan.longarticle.model.po.AccountSpecialSettingsExample;
import com.tzld.piaoquan.longarticle.model.po.PlanAccount;
import com.tzld.piaoquan.longarticle.model.po.PlanAccountExample;
import com.tzld.piaoquan.longarticle.service.local.AccountService;
import com.tzld.piaoquan.longarticle.utils.DateUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.List;

@Service
public class AccountServiceImpl implements AccountService {

    @Autowired
    private AccountSpecialSettingsMapper accountSpecialSettingsMapper;

    @Override
    public List<AccountSpecialSettings> getAccountSpecialSettings() {
        String dateString = DateUtil.getThatDayDateString();
        AccountSpecialSettingsExample example = new AccountSpecialSettingsExample();
        example.createCriteria().andEffectiveDateEqualTo(dateString);
        return accountSpecialSettingsMapper.selectByExample(example);
    }

    public void saveOrUpdateAccountSpecialSettings(AccountSpecialSettings accountSpecialSettings) {
        String dateString = DateUtil.getThatDayDateString();
        AccountSpecialSettingsExample example = new AccountSpecialSettingsExample();
        example.createCriteria().andEffectiveDateEqualTo(accountSpecialSettings.getAccountId())
                .andEffectiveDateEqualTo(accountSpecialSettings.getEffectiveDate());
        List<AccountSpecialSettings> accountSpecialSettingsList = accountSpecialSettingsMapper.selectByExample(example);
        if (CollectionUtils.isEmpty(accountSpecialSettingsList)) {
            accountSpecialSettingsMapper.insertSelective(accountSpecialSettings);
        } else {
            accountSpecialSettings.setId(accountSpecialSettingsList.get(0).getId());
            accountSpecialSettings.setIsDelete(0);
            accountSpecialSettingsMapper.updateByPrimaryKeySelective(accountSpecialSettings);
        }
    }
}
